import java.net.URL;
import javax.xml.rpc.*;
import javax.xml.rpc.encoding.*;
import javax.xml.namespace.QName;

public class MailServiceInvokerClient {


	protected ServiceFactory serviceFactory;
	protected Service service;
	protected Call call;
	protected String method = "sendMail";
	
	private String serviceEndPoint = "http://ece.uwaterloo.ca:8080/axis/e355gXX/MailServiceTemplate.jws"; 
	private String nameSpace = "http://ece:8080/axis/e355gXX/MailServiceTemplate.jws";

	public MailServiceInvokerClient(URL mailWSDLUrl, String serviceName) {
		
		try {
			serviceFactory = ServiceFactory.newInstance();
			service = serviceFactory.createService(mailWSDLUrl, 
					new QName(nameSpace, serviceName));
		} catch (Throwable t) {
			System.err.println("Error: Could not initialize Service Factory");
			t.printStackTrace();
		}

	}

   	public String invokeService(String fromAgent) throws Exception {

	       Call call = (Call) service.createCall();
	       call.setOperationName(new QName(nameSpace, method));

	       call.addParameter("from", XMLType.XSD_STRING, ParameterMode.IN);
	       call.setReturnType(XMLType.XSD_STRING);

	       call.setTargetEndpointAddress(serviceEndPoint);
       	       Object[] params = {fromAgent};	       
	       return (String) call.invoke(params);
       
	}

	public static void main(String[] args) throws Exception {

		MailServiceInvokerClient msi = new MailServiceInvokerClient(new URL(serviceEndpoint + "?wsdl"), "MailServiceTemplateService");

								 
		System.out.println(msi.invokeService("person@engmail.uwaterloo.ca"));
	}
}

