/*
 * Created on 26-Oct-2005
 * @author talguind
 *
 * Sample client to query services for organization
 */
import java.util.*;

import javax.xml.registry.infomodel.Association;
public class  WSQueryClient {
	
	public static void main(String[] args) {
		
		if (args.length < 1) {
            System.out.println("One argument required: " +
                "orgNamePattern");
            System.exit(1);
        }
		
		
        String orgNamePattern = new String(args[0]);
        System.out.println("Org name pattern  is " + orgNamePattern);
        
		// Use WebServices class to get services for org
		WebServicesQuery wsq = null ;
		wsq  = WebServicesQuery.getInstance();
		
		//  Get services info for orgs matching name pattern
		Collection serviceInfoColl = wsq.findServicesForOrg(orgNamePattern);
		if ( serviceInfoColl != null ){
			System.out.println("Found " + serviceInfoColl.size() + " services for o rg " + orgNamePattern) ;
			
			Iterator servIter = serviceInfoColl.iterator();
			while (servIter.hasNext()) {
				ServiceInfo servInfo = (ServiceInfo)servIter.next();
				System.out.println("Name: " + servInfo.getName()) ;
				System.out.println("Providing Organization: " + servInfo.getProvidingOrganization()) ;
				System.out.println("Description: " + servInfo.getDescription()) ;
				System.out.println("Service End Point " + servInfo.getEndPoint()) ;
				System.out.println("wsdl wri " + servInfo.getWsdluri()) ;
				System.out.println("---------------------------------");
			}		
		}
		else 
			System.out.println("There are no services for org " + orgNamePattern) ;
		
	}
	
}
