
import java.net.*;
import javax.net.*;
import java.io.*;
import java.util.*;

public class MailServiceTemplate {

	Socket tcpSocket;
        private String mailServer = "engmail.uwaterloo.ca";
	private int mailPort = 25;


	public String sendMail(String from) {
	        
		String res = null;	
		if (from.equals("person@engmail.uwaterloo.ca")) {
			res = buildMail("myFirstEmail@engmail.uwaterloo.ca", from);
		} else if (from.equals("importantPerson@engmail.uwaterloo.ca")) {
			res = buildMail("myPersonalEmail@engmail.uwaterloo.ca", from);
		}
		return res;
	}





	private String buildMail(String rcpt, String from) {
		PrintWriter mailWriter;
		BufferedReader mailReader;
		try {
			tcpSocket = new Socket (mailServer, mailPort);
			mailWriter = new PrintWriter(tcpSocket.getOutputStream());
			mailReader = new BufferedReader(new InputStreamReader(tcpSocket.getInputStream()));
		} catch (IOException e) {
			return "IOError: could not connect to the mail server : " +  e.getMessage();
		} 
		try {
			mailWriter.println("helo " + mailServer);
			mailWriter.println("mail from: " + from);
			mailWriter.println("rcpt to: " + rcpt);
		        mailWriter.println("data");
			mailWriter.println("Subject: Missed call from SIP Agent " + from);
		        mailWriter.println(buildMessage(from));	
			mailWriter.println(".");
			mailWriter.println("quit");
			mailWriter.flush();

			String responseLine;
			while ((responseLine = mailReader.readLine()) != null) {
				System.out.println(responseLine);
			}
			tcpSocket.close();
		} catch (Exception e) {
			return "SentMail Error: Sending the email Failed :" + e.getMessage();
		}

		return "Success";
	}

	private String buildMessage(String s) {
		return "Agent " + s + " called at " + new Date().toString();
	}

}


