package net.java.sip.communicator.ws;

import java.net.URL;
import javax.xml.rpc.*;
import javax.xml.rpc.encoding.*;
import javax.xml.namespace.QName;

public class MailServiceInvoker implements WebServiceInvoker {


	protected ServiceFactory serviceFactory;
	protected Service service;
	protected Call call;
	protected String method = "sendMail";
	private String serviceName = "MailServiceTemplateService"; // this should normally be gotten from the wsdl file
	private String serviceEndPoint;
	private String nameSpace = "http://ece:8080/axis/group00/MailServiceTemplate.jws";

	public MailServiceInvoker(String mailWSDLUrl, String serviceEndPoint) {
		
		try {
			this.serviceEndPoint = serviceEndPoint;

			serviceFactory = ServiceFactory.newInstance();
			service = serviceFactory.createService(new URL(mailWSDLUrl), 
					new QName(nameSpace, serviceName));
		} catch (Throwable t) {
			System.err.println("Error: Could not initialize Service Factory");
			t.printStackTrace();
		}

	}

   	public Object[] invokeService(Object[] params) throws Exception {

	       Call call = (Call) service.createCall();
	       call.setOperationName(new QName(nameSpace, method));

	       call.addParameter("from", XMLType.XSD_STRING, ParameterMode.IN);
	       call.setReturnType(XMLType.XSD_STRING);

	       call.setTargetEndpointAddress(serviceEndPoint);       	       	       
	       Object[] results =  {(String) call.invoke(params)};
       
	       return results;
	}
}

