package net.java.sip.communicator.ws;

import java.util.Calendar;
import java.util.Enumeration;
import java.util.GregorianCalendar;

import net.java.sip.communicator.PresenceStatusController;
import net.java.sip.communicator.SimpleContactList;
import net.java.sip.communicator.SipCommunicator;
import net.java.sip.communicator.common.CallLogger;
import net.java.sip.communicator.common.Console;
import net.java.sip.communicator.gui.GuiManager;
import net.java.sip.communicator.media.MediaManager;
import net.java.sip.communicator.sip.SipManager;

public class WebServicesInvocationWrapper  {
    private static SipCommunicator sipHandler;
    protected static Console console = Console.getConsole(SipCommunicator.class);
    // ECE355 - Solution
    protected static WebServicesInvocationWrapper wsWrapper = WebServicesInvocationWrapper.getInstance();
    // Web Services Wrapper id
    protected String id = "10";

    protected GuiManager               guiManager               = null;
    protected MediaManager             mediaManager             = null;
    protected SipManager               sipManager               = null;
    protected SimpleContactList        simpleContactList        = null;
    protected PresenceStatusController presenceStatusController = null;

    protected Integer unregistrationLock = new Integer(0);
    
    /** 
	 * Unique instance of this class(as in Singleton Pattern)
	 */
	private static WebServicesInvocationWrapper instance ;
	
	public static synchronized WebServicesInvocationWrapper getInstance(){
		if (instance == null) instance = new WebServicesInvocationWrapper();
		return instance ;
		
	}
    
	private WebServicesInvocationWrapper() {
	}
    
    

	public Object[] invokeService(String wsdlURL, String endPoint, Object[] params) throws Exception {
		// here is where you have to call the invoke method on the assigned 
		// strategy.
		WebServiceInvoker impl = new MailServiceInvoker(wsdlURL, endPoint);
		return impl.invokeService(params);
		
	}
		
	
	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}
	/**
	 * @param id The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}


}
